#[doc = "Register `PLD_MC_CFG_CEN_CONST` reader"]
pub struct R(crate::R<PLD_MC_CFG_CEN_CONST_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PLD_MC_CFG_CEN_CONST_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PLD_MC_CFG_CEN_CONST_SPEC>> for R {
    fn from(reader: crate::R<PLD_MC_CFG_CEN_CONST_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PLD_MC_CFG_CEN_CONST` writer"]
pub struct W(crate::W<PLD_MC_CFG_CEN_CONST_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PLD_MC_CFG_CEN_CONST_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PLD_MC_CFG_CEN_CONST_SPEC>> for W {
    fn from(writer: crate::W<PLD_MC_CFG_CEN_CONST_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC0_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD0_MC0_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC0_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC0_CEN` reader - Carry enable"]
pub struct PLD0_MC0_CEN_R(crate::FieldReader<bool, PLD0_MC0_CEN_A>);
impl PLD0_MC0_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC0_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC0_CEN_A {
        match self.bits {
            false => PLD0_MC0_CEN_A::DISABLE,
            true => PLD0_MC0_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD0_MC0_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD0_MC0_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD0_MC0_CEN_R {
    type Target = crate::FieldReader<bool, PLD0_MC0_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC0_CEN` writer - Carry enable"]
pub struct PLD0_MC0_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC0_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC0_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD0_MC0_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD0_MC0_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u16 & 0x01);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC0_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD0_MC0_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC0_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC0_DFF_C` reader - DFF Constant"]
pub struct PLD0_MC0_DFF_C_R(crate::FieldReader<bool, PLD0_MC0_DFF_C_A>);
impl PLD0_MC0_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC0_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC0_DFF_C_A {
        match self.bits {
            false => PLD0_MC0_DFF_C_A::NOINV,
            true => PLD0_MC0_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD0_MC0_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD0_MC0_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD0_MC0_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD0_MC0_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC0_DFF_C` writer - DFF Constant"]
pub struct PLD0_MC0_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC0_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC0_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD0_MC0_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD0_MC0_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u16 & 0x01) << 1);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC1_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD0_MC1_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC1_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC1_CEN` reader - Carry enable"]
pub struct PLD0_MC1_CEN_R(crate::FieldReader<bool, PLD0_MC1_CEN_A>);
impl PLD0_MC1_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC1_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC1_CEN_A {
        match self.bits {
            false => PLD0_MC1_CEN_A::DISABLE,
            true => PLD0_MC1_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD0_MC1_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD0_MC1_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD0_MC1_CEN_R {
    type Target = crate::FieldReader<bool, PLD0_MC1_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC1_CEN` writer - Carry enable"]
pub struct PLD0_MC1_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC1_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC1_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD0_MC1_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD0_MC1_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u16 & 0x01) << 2);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC1_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD0_MC1_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC1_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC1_DFF_C` reader - DFF Constant"]
pub struct PLD0_MC1_DFF_C_R(crate::FieldReader<bool, PLD0_MC1_DFF_C_A>);
impl PLD0_MC1_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC1_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC1_DFF_C_A {
        match self.bits {
            false => PLD0_MC1_DFF_C_A::NOINV,
            true => PLD0_MC1_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD0_MC1_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD0_MC1_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD0_MC1_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD0_MC1_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC1_DFF_C` writer - DFF Constant"]
pub struct PLD0_MC1_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC1_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC1_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD0_MC1_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD0_MC1_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | ((value as u16 & 0x01) << 3);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC2_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD0_MC2_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC2_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC2_CEN` reader - Carry enable"]
pub struct PLD0_MC2_CEN_R(crate::FieldReader<bool, PLD0_MC2_CEN_A>);
impl PLD0_MC2_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC2_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC2_CEN_A {
        match self.bits {
            false => PLD0_MC2_CEN_A::DISABLE,
            true => PLD0_MC2_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD0_MC2_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD0_MC2_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD0_MC2_CEN_R {
    type Target = crate::FieldReader<bool, PLD0_MC2_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC2_CEN` writer - Carry enable"]
pub struct PLD0_MC2_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC2_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC2_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD0_MC2_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD0_MC2_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | ((value as u16 & 0x01) << 4);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC2_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD0_MC2_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC2_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC2_DFF_C` reader - DFF Constant"]
pub struct PLD0_MC2_DFF_C_R(crate::FieldReader<bool, PLD0_MC2_DFF_C_A>);
impl PLD0_MC2_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC2_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC2_DFF_C_A {
        match self.bits {
            false => PLD0_MC2_DFF_C_A::NOINV,
            true => PLD0_MC2_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD0_MC2_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD0_MC2_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD0_MC2_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD0_MC2_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC2_DFF_C` writer - DFF Constant"]
pub struct PLD0_MC2_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC2_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC2_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD0_MC2_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD0_MC2_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | ((value as u16 & 0x01) << 5);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC3_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD0_MC3_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC3_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC3_CEN` reader - Carry enable"]
pub struct PLD0_MC3_CEN_R(crate::FieldReader<bool, PLD0_MC3_CEN_A>);
impl PLD0_MC3_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC3_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC3_CEN_A {
        match self.bits {
            false => PLD0_MC3_CEN_A::DISABLE,
            true => PLD0_MC3_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD0_MC3_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD0_MC3_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD0_MC3_CEN_R {
    type Target = crate::FieldReader<bool, PLD0_MC3_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC3_CEN` writer - Carry enable"]
pub struct PLD0_MC3_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC3_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC3_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD0_MC3_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD0_MC3_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 6)) | ((value as u16 & 0x01) << 6);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD0_MC3_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD0_MC3_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD0_MC3_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD0_MC3_DFF_C` reader - DFF Constant"]
pub struct PLD0_MC3_DFF_C_R(crate::FieldReader<bool, PLD0_MC3_DFF_C_A>);
impl PLD0_MC3_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD0_MC3_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD0_MC3_DFF_C_A {
        match self.bits {
            false => PLD0_MC3_DFF_C_A::NOINV,
            true => PLD0_MC3_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD0_MC3_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD0_MC3_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD0_MC3_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD0_MC3_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC3_DFF_C` writer - DFF Constant"]
pub struct PLD0_MC3_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD0_MC3_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD0_MC3_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD0_MC3_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD0_MC3_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 7)) | ((value as u16 & 0x01) << 7);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC0_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD1_MC0_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC0_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC0_CEN` reader - Carry enable"]
pub struct PLD1_MC0_CEN_R(crate::FieldReader<bool, PLD1_MC0_CEN_A>);
impl PLD1_MC0_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC0_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC0_CEN_A {
        match self.bits {
            false => PLD1_MC0_CEN_A::DISABLE,
            true => PLD1_MC0_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD1_MC0_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD1_MC0_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD1_MC0_CEN_R {
    type Target = crate::FieldReader<bool, PLD1_MC0_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC0_CEN` writer - Carry enable"]
pub struct PLD1_MC0_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC0_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC0_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD1_MC0_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD1_MC0_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | ((value as u16 & 0x01) << 8);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC0_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD1_MC0_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC0_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC0_DFF_C` reader - DFF Constant"]
pub struct PLD1_MC0_DFF_C_R(crate::FieldReader<bool, PLD1_MC0_DFF_C_A>);
impl PLD1_MC0_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC0_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC0_DFF_C_A {
        match self.bits {
            false => PLD1_MC0_DFF_C_A::NOINV,
            true => PLD1_MC0_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD1_MC0_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD1_MC0_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD1_MC0_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD1_MC0_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC0_DFF_C` writer - DFF Constant"]
pub struct PLD1_MC0_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC0_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC0_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD1_MC0_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD1_MC0_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | ((value as u16 & 0x01) << 9);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC1_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD1_MC1_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC1_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC1_CEN` reader - Carry enable"]
pub struct PLD1_MC1_CEN_R(crate::FieldReader<bool, PLD1_MC1_CEN_A>);
impl PLD1_MC1_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC1_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC1_CEN_A {
        match self.bits {
            false => PLD1_MC1_CEN_A::DISABLE,
            true => PLD1_MC1_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD1_MC1_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD1_MC1_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD1_MC1_CEN_R {
    type Target = crate::FieldReader<bool, PLD1_MC1_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC1_CEN` writer - Carry enable"]
pub struct PLD1_MC1_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC1_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC1_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD1_MC1_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD1_MC1_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | ((value as u16 & 0x01) << 10);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC1_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD1_MC1_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC1_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC1_DFF_C` reader - DFF Constant"]
pub struct PLD1_MC1_DFF_C_R(crate::FieldReader<bool, PLD1_MC1_DFF_C_A>);
impl PLD1_MC1_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC1_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC1_DFF_C_A {
        match self.bits {
            false => PLD1_MC1_DFF_C_A::NOINV,
            true => PLD1_MC1_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD1_MC1_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD1_MC1_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD1_MC1_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD1_MC1_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC1_DFF_C` writer - DFF Constant"]
pub struct PLD1_MC1_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC1_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC1_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD1_MC1_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD1_MC1_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | ((value as u16 & 0x01) << 11);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC2_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD1_MC2_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC2_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC2_CEN` reader - Carry enable"]
pub struct PLD1_MC2_CEN_R(crate::FieldReader<bool, PLD1_MC2_CEN_A>);
impl PLD1_MC2_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC2_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC2_CEN_A {
        match self.bits {
            false => PLD1_MC2_CEN_A::DISABLE,
            true => PLD1_MC2_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD1_MC2_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD1_MC2_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD1_MC2_CEN_R {
    type Target = crate::FieldReader<bool, PLD1_MC2_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC2_CEN` writer - Carry enable"]
pub struct PLD1_MC2_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC2_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC2_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD1_MC2_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD1_MC2_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | ((value as u16 & 0x01) << 12);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC2_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD1_MC2_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC2_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC2_DFF_C` reader - DFF Constant"]
pub struct PLD1_MC2_DFF_C_R(crate::FieldReader<bool, PLD1_MC2_DFF_C_A>);
impl PLD1_MC2_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC2_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC2_DFF_C_A {
        match self.bits {
            false => PLD1_MC2_DFF_C_A::NOINV,
            true => PLD1_MC2_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD1_MC2_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD1_MC2_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD1_MC2_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD1_MC2_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC2_DFF_C` writer - DFF Constant"]
pub struct PLD1_MC2_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC2_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC2_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD1_MC2_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD1_MC2_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | ((value as u16 & 0x01) << 13);
        self.w
    }
}
#[doc = "Carry enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC3_CEN_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<PLD1_MC3_CEN_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC3_CEN_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC3_CEN` reader - Carry enable"]
pub struct PLD1_MC3_CEN_R(crate::FieldReader<bool, PLD1_MC3_CEN_A>);
impl PLD1_MC3_CEN_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC3_CEN_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC3_CEN_A {
        match self.bits {
            false => PLD1_MC3_CEN_A::DISABLE,
            true => PLD1_MC3_CEN_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == PLD1_MC3_CEN_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == PLD1_MC3_CEN_A::ENABLE
    }
}
impl core::ops::Deref for PLD1_MC3_CEN_R {
    type Target = crate::FieldReader<bool, PLD1_MC3_CEN_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC3_CEN` writer - Carry enable"]
pub struct PLD1_MC3_CEN_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC3_CEN_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC3_CEN_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(PLD1_MC3_CEN_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(PLD1_MC3_CEN_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 14)) | ((value as u16 & 0x01) << 14);
        self.w
    }
}
#[doc = "DFF Constant\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum PLD1_MC3_DFF_C_A {
    #[doc = "0: No description available"]
    NOINV = 0,
    #[doc = "1: No description available"]
    INVERTED = 1,
}
impl From<PLD1_MC3_DFF_C_A> for bool {
    #[inline(always)]
    fn from(variant: PLD1_MC3_DFF_C_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `PLD1_MC3_DFF_C` reader - DFF Constant"]
pub struct PLD1_MC3_DFF_C_R(crate::FieldReader<bool, PLD1_MC3_DFF_C_A>);
impl PLD1_MC3_DFF_C_R {
    pub(crate) fn new(bits: bool) -> Self {
        PLD1_MC3_DFF_C_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> PLD1_MC3_DFF_C_A {
        match self.bits {
            false => PLD1_MC3_DFF_C_A::NOINV,
            true => PLD1_MC3_DFF_C_A::INVERTED,
        }
    }
    #[doc = "Checks if the value of the field is `NOINV`"]
    #[inline(always)]
    pub fn is_noinv(&self) -> bool {
        **self == PLD1_MC3_DFF_C_A::NOINV
    }
    #[doc = "Checks if the value of the field is `INVERTED`"]
    #[inline(always)]
    pub fn is_inverted(&self) -> bool {
        **self == PLD1_MC3_DFF_C_A::INVERTED
    }
}
impl core::ops::Deref for PLD1_MC3_DFF_C_R {
    type Target = crate::FieldReader<bool, PLD1_MC3_DFF_C_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC3_DFF_C` writer - DFF Constant"]
pub struct PLD1_MC3_DFF_C_W<'a> {
    w: &'a mut W,
}
impl<'a> PLD1_MC3_DFF_C_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: PLD1_MC3_DFF_C_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn noinv(self) -> &'a mut W {
        self.variant(PLD1_MC3_DFF_C_A::NOINV)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn inverted(self) -> &'a mut W {
        self.variant(PLD1_MC3_DFF_C_A::INVERTED)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 15)) | ((value as u16 & 0x01) << 15);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc0_cen(&self) -> PLD0_MC0_CEN_R {
        PLD0_MC0_CEN_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc0_dff_c(&self) -> PLD0_MC0_DFF_C_R {
        PLD0_MC0_DFF_C_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc1_cen(&self) -> PLD0_MC1_CEN_R {
        PLD0_MC1_CEN_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc1_dff_c(&self) -> PLD0_MC1_DFF_C_R {
        PLD0_MC1_DFF_C_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc2_cen(&self) -> PLD0_MC2_CEN_R {
        PLD0_MC2_CEN_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc2_dff_c(&self) -> PLD0_MC2_DFF_C_R {
        PLD0_MC2_DFF_C_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 6 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc3_cen(&self) -> PLD0_MC3_CEN_R {
        PLD0_MC3_CEN_R::new(((self.bits >> 6) & 0x01) != 0)
    }
    #[doc = "Bit 7 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc3_dff_c(&self) -> PLD0_MC3_DFF_C_R {
        PLD0_MC3_DFF_C_R::new(((self.bits >> 7) & 0x01) != 0)
    }
    #[doc = "Bit 8 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc0_cen(&self) -> PLD1_MC0_CEN_R {
        PLD1_MC0_CEN_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc0_dff_c(&self) -> PLD1_MC0_DFF_C_R {
        PLD1_MC0_DFF_C_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc1_cen(&self) -> PLD1_MC1_CEN_R {
        PLD1_MC1_CEN_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc1_dff_c(&self) -> PLD1_MC1_DFF_C_R {
        PLD1_MC1_DFF_C_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc2_cen(&self) -> PLD1_MC2_CEN_R {
        PLD1_MC2_CEN_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc2_dff_c(&self) -> PLD1_MC2_DFF_C_R {
        PLD1_MC2_DFF_C_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 14 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc3_cen(&self) -> PLD1_MC3_CEN_R {
        PLD1_MC3_CEN_R::new(((self.bits >> 14) & 0x01) != 0)
    }
    #[doc = "Bit 15 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc3_dff_c(&self) -> PLD1_MC3_DFF_C_R {
        PLD1_MC3_DFF_C_R::new(((self.bits >> 15) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc0_cen(&mut self) -> PLD0_MC0_CEN_W {
        PLD0_MC0_CEN_W { w: self }
    }
    #[doc = "Bit 1 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc0_dff_c(&mut self) -> PLD0_MC0_DFF_C_W {
        PLD0_MC0_DFF_C_W { w: self }
    }
    #[doc = "Bit 2 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc1_cen(&mut self) -> PLD0_MC1_CEN_W {
        PLD0_MC1_CEN_W { w: self }
    }
    #[doc = "Bit 3 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc1_dff_c(&mut self) -> PLD0_MC1_DFF_C_W {
        PLD0_MC1_DFF_C_W { w: self }
    }
    #[doc = "Bit 4 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc2_cen(&mut self) -> PLD0_MC2_CEN_W {
        PLD0_MC2_CEN_W { w: self }
    }
    #[doc = "Bit 5 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc2_dff_c(&mut self) -> PLD0_MC2_DFF_C_W {
        PLD0_MC2_DFF_C_W { w: self }
    }
    #[doc = "Bit 6 - Carry enable"]
    #[inline(always)]
    pub fn pld0_mc3_cen(&mut self) -> PLD0_MC3_CEN_W {
        PLD0_MC3_CEN_W { w: self }
    }
    #[doc = "Bit 7 - DFF Constant"]
    #[inline(always)]
    pub fn pld0_mc3_dff_c(&mut self) -> PLD0_MC3_DFF_C_W {
        PLD0_MC3_DFF_C_W { w: self }
    }
    #[doc = "Bit 8 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc0_cen(&mut self) -> PLD1_MC0_CEN_W {
        PLD1_MC0_CEN_W { w: self }
    }
    #[doc = "Bit 9 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc0_dff_c(&mut self) -> PLD1_MC0_DFF_C_W {
        PLD1_MC0_DFF_C_W { w: self }
    }
    #[doc = "Bit 10 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc1_cen(&mut self) -> PLD1_MC1_CEN_W {
        PLD1_MC1_CEN_W { w: self }
    }
    #[doc = "Bit 11 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc1_dff_c(&mut self) -> PLD1_MC1_DFF_C_W {
        PLD1_MC1_DFF_C_W { w: self }
    }
    #[doc = "Bit 12 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc2_cen(&mut self) -> PLD1_MC2_CEN_W {
        PLD1_MC2_CEN_W { w: self }
    }
    #[doc = "Bit 13 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc2_dff_c(&mut self) -> PLD1_MC2_DFF_C_W {
        PLD1_MC2_DFF_C_W { w: self }
    }
    #[doc = "Bit 14 - Carry enable"]
    #[inline(always)]
    pub fn pld1_mc3_cen(&mut self) -> PLD1_MC3_CEN_W {
        PLD1_MC3_CEN_W { w: self }
    }
    #[doc = "Bit 15 - DFF Constant"]
    #[inline(always)]
    pub fn pld1_mc3_dff_c(&mut self) -> PLD1_MC3_DFF_C_W {
        PLD1_MC3_DFF_C_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Macrocell configuration for Carry Enable and Constant\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pld_mc_cfg_cen_const](index.html) module"]
pub struct PLD_MC_CFG_CEN_CONST_SPEC;
impl crate::RegisterSpec for PLD_MC_CFG_CEN_CONST_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [pld_mc_cfg_cen_const::R](R) reader structure"]
impl crate::Readable for PLD_MC_CFG_CEN_CONST_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pld_mc_cfg_cen_const::W](W) writer structure"]
impl crate::Writable for PLD_MC_CFG_CEN_CONST_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PLD_MC_CFG_CEN_CONST to value 0"]
impl crate::Resettable for PLD_MC_CFG_CEN_CONST_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
